﻿/*
Copyright (c) <2012>, Intel Corporation All Rights Reserved.

The source code, information and material ("Material") contained herein is 
owned by Intel Corporation or its suppliers or licensors, and title to such 
Material remains with Intel Corporation or its suppliers or licensors. The 
Material contains proprietary information of Intel or its suppliers and 
licensors. The Material is protected by worldwide copyright laws and treaty 
provisions. No part of the Material may be used, copied, reproduced, 
modified, published, uploaded, posted, transmitted, distributed or 
disclosed in any way without Intel's prior express written permission. No 
license under any patent, copyright or other intellectual property rights 
in the Material is granted to or conferred upon you, either expressly, by 
implication, inducement, estoppel or otherwise. Any license under such 
intellectual property rights must be express and approved by Intel in 
writing.

Copyright (c) Microsoft Corporation. All rights reserved

Unless otherwise agreed by Intel in writing, you may not remove or alter 
this notice or any other notice embedded in Materials by Intel or Intel’s 
suppliers or licensors in any way.
*/


//
// MainPage.xaml.cpp
// Implementation of the MainPage class.
//

#include "pch.h"
#include "MainPage.xaml.h"

using namespace App1;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;
using namespace Windows::UI::Xaml::Shapes;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238


MainPage::MainPage()
{
	InitializeComponent();
	
	//starting with red in color gradient;
	currentAngle = 0;
}

/// <summary>
/// Invoked when this page is about to be displayed in a Frame.
/// </summary>
/// <param name="e">Event data that describes how this page was reached.  The Parameter
/// property is typically used to configure the page.</param>
void MainPage::OnNavigatedTo(NavigationEventArgs^ e)
{
	(void) e;	// Unused parameter
}


void App1::MainPage::SDP_Rect_PointerPressed(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{
	Rectangle^ rect = safe_cast<Rectangle^>(sender);
	SolidColorBrush^ brush; 

    // Paint the border of the rectangle blue
    if (nullptr != rect)
    {
		brush = safe_cast<SolidColorBrush^>(rect->Stroke);
		brush->Color = Windows::UI::Colors::Blue;
    }
}


void App1::MainPage::SDP_Rect_PointerReleased(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{
	Rectangle^ rect = safe_cast<Rectangle^>(sender);
	SolidColorBrush^ stroke_brush; 
	SolidColorBrush^ fill_brush; 

    // Set the border of the rectangle to match the fill color
    if (nullptr != rect)
    {
		stroke_brush = safe_cast<SolidColorBrush^>(rect->Stroke);
		fill_brush = safe_cast<SolidColorBrush^>(rect->Fill);
		stroke_brush->Color = fill_brush->Color;
    }

}


void App1::MainPage::SDP_Rect_PointerExited(Platform::Object^ sender, Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e)
{
	Rectangle^ rect = safe_cast<Rectangle^>(sender);

    // Finger moved out of Rectangle before the pointer exited event.
    // Reset the dimensions on the Rectangle.
    if (nullptr != rect)
    {
        //place your code to handle this specific event here.
    }

}


void App1::MainPage::SDP_Rect_DoubleTapped(Platform::Object^ sender, Windows::UI::Xaml::Input::DoubleTappedRoutedEventArgs^ e)
{
	Rectangle^ rect = safe_cast<Rectangle^>(sender);

    if (nullptr != rect)
    {
		rect->Width += 20;
		rect->Height += 20;
	}
}


void App1::MainPage::SDP_Rect_Tapped(Platform::Object^ sender, Windows::UI::Xaml::Input::TappedRoutedEventArgs^ e)
{
	Rectangle^ rect = safe_cast<Rectangle^>(sender);

    if (nullptr != rect)
    {
		// Place code here for reacting to a single tap event
	}
}


void App1::MainPage::SDP_Rect_ManipulationDelta(Platform::Object^ sender, Windows::UI::Xaml::Input::ManipulationDeltaRoutedEventArgs^ e)
{
	Rectangle^ rect = safe_cast<Rectangle^>(sender);
	SolidColorBrush^ brush; 
	float rotation = e->Delta.Rotation;
	int drag = 1;

	//Rotation
	if (e->Delta.Rotation != 0)
	{
		brush = safe_cast<SolidColorBrush^>(rect->Fill);
		currentAngle += e->Delta.Rotation;
		if (currentAngle > 360)
			currentAngle -= 360;
		if (currentAngle < 0)
			currentAngle += 360;
		
		SDP_Rect_Change_Color(currentAngle, brush);
		drag = 0;
	}
	//It's a pinch
	if (e->Delta.Expansion != 0)
	{
		rect->Width += e->Delta.Expansion;
		rect->Height += e->Delta.Expansion;
		drag = 0;
	}
	//It's a finger drag.  
	if(drag)
	{
		trans_drag->X += e->Delta.Translation.X;
		trans_drag->Y += e->Delta.Translation.Y;
	}
}

void App1::MainPage::SDP_Rect_Change_Color(float degrees, SolidColorBrush^ brush)
{
	int r = 255;
	int g = 0;
	int b = 0;

	//green up
	if (degrees < 60)
		g = (int) ((degrees/60) * 255);
	//red down
	else if (degrees > 59 && degrees < 120)
	{
		degrees -= 60;
		g=255;
		r = (int) ((1-(degrees/60)) * 255);
	}
	//blue up
	else if (degrees > 119 && degrees < 180)
	{
		degrees -= 120;
		r = 0;
		g = 255;
		b = (int) ((degrees/60) * 255);
	}
	//green down
	else if (degrees > 179 && degrees < 240)
	{
		degrees -= 180;
		r = 0;
		b = 255;
		g = (int) ((1-(degrees /60)) * 255);
	}
	//red up
	else if (degrees > 239 && degrees < 300)
	{
		degrees -= 240;
		b = 255;
		g = 0;
		r = (int) ((degrees/60) * 255);
	}
	//blue down
	else if (degrees > 299 && degrees < 360)
	{
		degrees -= 300;
		r = 255;
		g = 0;
		b = (int) ((1-(degrees /60)) * 255);
	}
	else 
	{
		r = 255;
		g = 0;
		b = 0;
	}
	brush->Color = Windows::UI::ColorHelper::FromArgb(255,r,g,b);
}
